summaryrefslogtreecommitdiff
path: root/tests
diff options
context:
space:
mode:
authorPádraig Brady <P@draigBrady.com>2010-04-28 23:54:33 +0100
committerPádraig Brady <P@draigBrady.com>2010-04-29 18:55:57 +0100
commit8b5087d4e62439503e3cba774de225893b9ea81a (patch)
tree7ac7a407ac5368ca46082a807f17c16d009ded31 /tests
parent7905d6d34dbeb73ef03b3c75f66dde9036634775 (diff)
downloadcoreutils-8b5087d4e62439503e3cba774de225893b9ea81a.tar.xz
sort: use long doubles for general numeric mode
* src/sort.c (general_numcompare): Use long doubles unconditionally, and strtold when available, to convert numbers with greater range and precision. Performance was seen to be on par with standard doubles. * doc/coreutils.texi (sort invocation): Amend the -g description to mention long double rather than double, and strtold rather than strtod. * src/getlimits.c (main): Output floating point limits for use in tests. * tests/misc/sort-float: A new test to ensure sort is using long doubles when possible, and that locale specific floats are handled. * tests/Makefile.am: Reference the new test. * tests/test-lib.sh (getlimits_): Normalize indenting. * NEWS: Mention the new behaviour. Reported by Nelson Beebe.
Diffstat (limited to 'tests')
-rw-r--r--tests/Makefile.am1
-rwxr-xr-xtests/misc/sort-float56
-rw-r--r--tests/test-lib.sh4
3 files changed, 59 insertions, 2 deletions
diff --git a/tests/Makefile.am b/tests/Makefile.am
index a943ff3ab..b78b75d67 100644
--- a/tests/Makefile.am
+++ b/tests/Makefile.am
@@ -224,6 +224,7 @@ TESTS = \
misc/sort-compress \
misc/sort-continue \
misc/sort-files0-from \
+ misc/sort-float \
misc/sort-merge \
misc/sort-merge-fdlimit \
misc/sort-month \
diff --git a/tests/misc/sort-float b/tests/misc/sort-float
new file mode 100755
index 000000000..639cd7eae
--- /dev/null
+++ b/tests/misc/sort-float
@@ -0,0 +1,56 @@
+#!/bin/sh
+# Ensure sort -g sorts floating point limits correctly
+
+# Copyright (C) 2010 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ sort --version
+fi
+
+. $srcdir/test-lib.sh
+
+for LOC in C $LOCALE_FR; do
+
+ LC_ALL=$LOC getlimits_
+
+ # See if sort should be using long doubles
+ grep '^#define HAVE_C99_STRTOLD 1' $CONFIG_HEADER > /dev/null ||
+ { LDBL_MAX="$DBL_MAX"; LDBL_MIN="$DBL_MIN"; }
+
+ printf -- "\
+-$LDBL_MAX
+-$DBL_MAX
+-$FLT_MAX
+-$FLT_MIN
+-$DBL_MIN
+-$LDBL_MIN
+0
+$LDBL_MIN
+$DBL_MIN
+$FLT_MIN
+$FLT_MAX
+$DBL_MAX
+$LDBL_MAX
+" |
+ grep '^[0-9.,e+-]*$' > exp # restrict to numeric just in case
+
+ tac exp | LC_ALL=$LOC sort -sg > out || fail=1
+
+ compare out exp || fail=1
+done
+
+Exit $fail
diff --git a/tests/test-lib.sh b/tests/test-lib.sh
index a62857bdb..ac2f8bf41 100644
--- a/tests/test-lib.sh
+++ b/tests/test-lib.sh
@@ -57,8 +57,8 @@ skip_test_()
getlimits_()
{
- eval $(getlimits)
- test "$INT_MAX" ||
+ eval $(getlimits)
+ test "$INT_MAX" ||
error_ "Error running getlimits"
}